'''Dungeons and Dragons Mod for Source
First Version found @ http://addons.eventscripts.com/addons/view/dnd
Mod Based of Dungeons and Dragons 4.0 System (Pen and Paper)
Preview Info: http://dnd4.com/phb
By: J3ff Hoogland'''
import es, popuplib, random, gamethread, cPickle, os.path, math, langlib, playerlib
info = es.AddonInfo()
info.name = 'Dungeons and Dragons: Source'
info.version = '0.0.4 Python'
info.url = 'http://addons.eventscripts.com/addons/view/dnds'
info.basename = 'dnds'
info.author = 'J3ff Hoogland'
es.ServerVar('D&D',info.version,'Dungeons and Dragons By: J3ff Hoogland').makepublic()
#Being Events
#Begin Player Events
def player_spawn(ev):
    userid = int(ev['userid'])
    Player(userid).CheckCharacter()
    if Character(userid).key['race'] is 'Pending':
        Menu(userid).RaceMenu()
    elif not len(Character(userid).key['classes']):
        Menu(userid).ClassMenu()
    elif Character(userid).key['unspent level']:
        Menu(userid).MultiMenu()
def player_death(ev):
    global Players
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if ev['es_attackerteam'] is not ev['es_userteam']:
        Character(userid).GiveXp(int(es.ServerVar('dnds_KillXp')), text('player_death 1',{'es_username':ev['es_username']},playerlib.getPlayer(userid).get('lang')))
    if Players.has_key(userid):
        for d in Players[userid]['delay list']:
            gamethread.cancelDelayed(d)
        Players[userid]['delay list'] = []
def player_hurt(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if dir is not 'cstrike' and dir is not 'dod':
        es.event('initialize', 'player_damage')
        es.event('setint','player_damage','userid',userid)
        es.event('setint','player_damage','dmg_health',int(es.getplayerprop(userid,'CBasePlayer.m_iHealth'))-Player(userid).key['health'])
        es.event('setint','player_damage','attacker',attacker)
        es.event('setstring','player_damage','weapon',playerlib.getPlayer(attacker).get('weapon'))
        es.event('setint','player_damage','health',int(es.getplayerprop(userid,'CBasePlayer.m_iHealth')))
        es.event('fire','player_damage')
#End Player Events
#Begin global events
def es_map_start(ev):
    es.loadevents('declare', 'addons/eventscripts/dnds/events.res')
def round_end(ev):
    global Players
    winner = int(ev['winner'])
    for d in Players['delay list']:
        gamethread.cancelDelayed(d)
    Players['delay list'] = []
    for id in Players:
        if id != 'delay list':
            for d in Players[id]['delay list']:
                gamethread.cancelDelayed(d)
            Players[id]['delay list'] = []
#End global events
#End Events
#Our looping method that handel things such as saving and messaging that the mod is running
def LoopBlock():
    for userid in es.getUseridList():
        es.tell(id, '#multi', text('LoopBlock 1',{},playerlib.getPlayer(userid).get('lang')))
    str_path = open(es.getAddonPath('dnds') + '/Characters.db', 'w')
    cPickle.dump(Characters, str_path)
    str_path.close()
    gamethread.delayedname(30, 'dnds loop', LoopBlock)
#Looping block that keep's all user's gravity at the correct amount
def GravityCheck():
    for id in es.getUseridList():
        es.server.queuecmd('es_xfire %s %s %s %s'%(id, '!self', 'addoutput', '"gravity %s"'%Player(id).key['gravity']))
    gamethread.delayedname(0.5, 'dnds gravity', GravityCheck)
#Loops everytime the server tics (used to player_damage for none CSS games)
def Ticker():
    for id in es.getUseridList():
        Player(id).key['health'] = int(es.getplayerprop(id,'CBasePlayer.m_iHealth'))
#End looping block
#Begin Load Method (And commands)
Players = {'delay list':[]}
Races = {'Dragonborn':{'info':[]},
    'Dwarf':{'info':[]},
    'Eladrin':{'info':[]},
    'Elf':{'info':[]},
    'Half Elf':{'info':[]},
    'Halfling':{'info':[]},
    'Human':{'info':[]},
    'Tiefling':{'info':[]}}
Race_List = ['Dragonborn','Dwarf','Eladrin','Elf','Half Elf','Halfling','Human','Tiefling']
Classes = {'Cleric':{'info':[]},
    'Fighter':{'info':[]},
    'Paladin':{'info':[]},
    'Ranger':{'info':[]},
    'Rogue':{'info':[]},
    'Warlock':{'info':[]},
    'Warlord':{'info':[]},
    'Wizard':{'info':[]}}
Class_List = ['Cleric','Fighter','Paladin','Ranger','Rogue','Warlock','Warlord','Wizard']
Characters = {}
#                     Level : Xp Needed to Obtain it
Levels = {2:1000,
    3:2250,
    4:3750,
    5:5500,
    6:7500,
    7:10000,
    8:13000,
    9:16500,
    10:20500,
    11:25500,
    12:31500,
    13:38500,
    14:46500,
    15:56500,
    16:68500,
    17:82500,
    18:98500,
    19:118500,
    20:142500,
    21:170500,
    22:202500,
    23:244000,
    24:295000,
    25:355500,
    26:425500,
    27:515500,
    28:625500,
    29:755500,
    30:905500}
def load():
    es.dbgmsg(0, '[Dungeons and Dragons] - Begin Load')
    global text, Characters, dir, game
    text = langlib.Strings(es.getAddonPath('dnds') + '/strings.ini')
    str_path = es.getAddonPath('dnds') + '/Characters.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        Characters = cPickle.load(file_users)
        file_users.close()
    dir = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').split('/')[~0]
    if dir == 'cstrike':
        game = 'Counter-Strike: Source'
    elif dir == 'hl2mp':
        game = 'Half Life 2 Deathmatch'
    elif dir == 'dod':
        game = 'Day of Defeat: Source'
    elif dir == 'pvkii':
        game = 'Pirates, Vikings, and Knights'
    elif dir == 'tf':
        game = 'Team Fortress 2'
    else:
        game = 'Unknown'
    es.dbgmsg(0, '[Dungeons and Dragons] - Game %s'%game)
    es.dbgmsg(0, '[Dungeons and Dragons] - Directory %s'%dir)
    if not es.exists('saycommand', 'dnd'):
        es.regsaycmd('dnd', 'dnds/Command')
    if not es.exists('clientcommand', 'dnd'):
        es.regclientcmd('dnd', 'dnds/Command')
    ServerVars = {'dnds_KillXp':60}
    for x in ServerVars:
        es.ServerVar(x).set(ServerVars[x])
    es.mexec('..addons/eventscripts/dnds/dnds.cfg')
    LoopBlock()
    GravityCheck()
    if dir is not 'cstrike' and dir is not 'dod':
        es.addons.registerTickListener(Ticker)
    es.dbgmsg(0, '[Dungeons and Dragons] - Load Finished')
#End Load Methods
#Begin unload methods
def unload():
    es.dbgmsg(0, '[Dungeons and Dragons] - Unload Start')
    if dir is not 'cstrike' and dir is not 'dod':
        es.addons.unregisterTickListener(Ticker)
    for d in Players['delay list']:
        gamethread.cancelDelayed(d)
    for id in Players:
        if id != 'delay list':
            for d in Players[id]['delay list']:
                gamethread.cancelDelayed(d)
    for d in ['dnds loop', 'dnds gravity']:
        gamethread.cancelDelayed(d)
    es.dbgmsg(0, '[Dungeons and Dragons] - Unload End')
#end unload methods
#Begin global methods
#End global methods
#Begin Classes
#Our menu class, handels all static and dynamic menus
class Menu(object):
    def __init__(self, userid):
        self.userid = int(userid)
        Player(self.userid).Update()
        Character(self.userid).Update()
        self.name = es.getplayername(self.userid)
        if not Players[self.userid]['character']:
            Player(userid).CheckCharacter()
        self.character = Players[self.userid]['character']
        self.characterkey = Characters[self.character]
        self.player = playerlib.getPlayer(self.userid)
        self.user = Player(self.userid)
        count = popuplib.active(self.userid)['count']
        #es.msg(popuplib.active(self.userid))
        while count:
            count -= 1
            popuplib.close(popuplib.active(self.userid)['name'], self.userid)
    def MainMenu(self, userid=None, choice=None, popupid=None):
        MMenu = popuplib.create('MMenu')
        for i in range(1, 8):
            MMenu.addline(text('MainMenu %s'%i,{},playerlib.getPlayer(self.userid).get('lang')))
        MMenu.menuselect = self.MainMenuSelect
        MMenu.send(self.userid)
    def MainMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            if self.player.get('isdead'):
                es.tell(self.userid, '#multi', text('MainMenuSelect 1',{},playerlib.getPlayer(self.userid).get('lang')))
                es.escinputbox(10, self.userid, text('MainMenuSelect 2',{},playerlib.getPlayer(self.userid).get('lang')), text('MainMenuSelect 3',{},playerlib.getPlayer(self.userid).get('lang')), 'dnd create')
            else:
                es.tell(self.userid, '#multi', text('MainMenuSelect 4',{},playerlib.getPlayer(self.userid).get('lang')))
        elif choice == 2:
            Player(self.userid).CharacterMenu()
        elif choice == 3:
            self.CharacterInformation()
        elif choice == 6:
            self.InfoMenu()
        elif choice == 7:
            self.HelpMenu()
    def CharacterInformation(self, userid=None, choice=None, popupid=None):
        if popuplib.exists('statsmenu'):
            popuplib.delete('statsmenu')
        statsmenu = popuplib.create('statsmenu')
        statsmenu.addline(text('CharacterInformation 1',{},playerlib.getPlayer(self.userid).get('lang')))
        statsmenu.addline(text('CharacterInformation 2',{'character':self.character},playerlib.getPlayer(self.userid).get('lang')))
        statsmenu.addline(text('CharacterInformation 3',{'xp':self.characterkey['xp']},playerlib.getPlayer(self.userid).get('lang')))
        statsmenu.addline(text('CharacterInformation 4',{'race':self.characterkey['race']},playerlib.getPlayer(self.userid).get('lang')))
        statsmenu.addline(text('CharacterInformation 5',{},playerlib.getPlayer(self.userid).get('lang')))
        for c in sorted(self.characterkey['classes'].keys()):
            statsmenu.addline(' - %s (Level %s)'%(c, self.characterkey['classes'][c]['level']))
        statsmenu.addline(text('CharacterInformation 6',{},playerlib.getPlayer(self.userid).get('lang')))
        statsmenu.addline(text('CharacterInformation 7',{},playerlib.getPlayer(self.userid).get('lang')))
        statsmenu.menuselect = self.CISelect
        statsmenu.send(self.userid)
    def CISelect(self, userid=None, choice=None, popupid=None):
        if choice is 9:
            self.MainMenu()
    def HelpMenu(self, userid=None, choice=None, popupid=None):
        welcomemenu = popuplib.create('welcomemenu')
        for i in range(1, 11):
            welcomemenu.addline(text('HelpMenu %s'%i,{},playerlib.getPlayer(self.userid).get('lang')))
        welcomemenu.menuselect = self.MainMenu
        welcomemenu.send(self.userid)
    def InfoMenu(self, userid=None, choice=None, popupid=None):
        infomenu = popuplib.create('infomenu')
        for i in range(1, 6):
            infomenu.addline(text('InfoMenu %s'%i,{},playerlib.getPlayer(self.userid).get('lang')))
        infomenu.menuselect = self.InfoSelect
        infomenu.send(self.userid)
    def InfoSelect(self, userid=None, choice=None, popupid=None):
        if choice is 9:
            self.MainMenu()
        elif choice is 2:
            self.ClassInfo()
        elif choice is 1:
            self.RaceInfo()
    def RaceMenu(self, userid=None, choice=None, popupid=None):
        RMenu = popuplib.easymenu('race menu', None, self.RaceSelect)
        RMenu.settitle(text('RaceMenu 1',{},playerlib.getPlayer(self.userid).get('lang')))
        for race in Race_List:
            RMenu.addoption(race, race)
        RMenu.addoption('info', text('RaceMenu 2',{},playerlib.getPlayer(self.userid).get('lang')))
        RMenu.send(self.userid)
    def RaceSelect(self, userid=None, choice=None, popupid=None):
        if choice is not 'info':
            self.characterkey['race'] = choice
            es.tell(self.userid, '#multi', text('RaceSelect 1',{'race':choice},playerlib.getPlayer(self.userid).get('lang')))
            self.ClassMenu()
        else:
            self.RaceInfo()
    def RaceInfo(self, userid=None, choice=None, popupid=None):
        RMenu = popuplib.easymenu('race info', None, self.RaceInfoSelect)
        RMenu.settitle(text('RaceInfo 1',{},playerlib.getPlayer(self.userid).get('lang')))
        for race in Race_List:
            RMenu.addoption(race, race)
        if self.characterkey['race'] is 'Pending':
            RMenu.addoption('pick', text('RaceInfo 2',{},playerlib.getPlayer(self.userid).get('lang')))
        RMenu.addoption('back', text('RaceInfo 3',{},playerlib.getPlayer(self.userid).get('lang')))
        RMenu.send(self.userid)
    def RaceInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice is 'pick':
            self.RaceMenu()
        elif choice is 'back':
            self.InfoMenu()
        else:
            infomenu = popuplib.create('%s info'%choice)
            infomenu.addline(text('RaceInfoSelect 1',{'choice':choice},playerlib.getPlayer(self.userid).get('lang')))
            for line in Races[choice]['info']:
                infomenu.addline(line)
            if self.characterkey['race'] is 'Pending':
                self.user.key['pending'] = choice
                infomenu.addline(text('RaceInfoSelect 2',{},playerlib.getPlayer(self.userid).get('lang')))
            infomenu.addline(text('RaceInfoSelect 3',{},playerlib.getPlayer(self.userid).get('lang')))
            infomenu.addline(text('RaceInfoSelect 4',{},playerlib.getPlayer(self.userid).get('lang')))
            infomenu.menuselect = self.InfoRaceSelect
            infomenu.send(self.userid)
    def InfoRaceSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8 and self.user.key['pending'] and self.characterkey['race'] is 'Pending':
            self.RaceSelect(choice=self.user.key['pending'])
        elif choice is 9:
            self.RaceInfo()
        self.user.key['pending'] = None
    def ClassMenu(self, userid=None, choice=None, popupid=None):
        CMenu = popuplib.easymenu('Class menu', None, self.ClassSelect)
        CMenu.settitle(text('ClassMenu 1',{},playerlib.getPlayer(self.userid).get('lang')))
        for Class in Class_List:
            CMenu.addoption(Class, Class)
        CMenu.addoption('info', text('ClassMenu 2',{},playerlib.getPlayer(self.userid).get('lang')))
        CMenu.send(self.userid)
    def ClassSelect(self, userid=None, choice=None, popupid=None):
        if choice is not 'info':
            self.characterkey['classes'][choice] = {'level':1}
            es.tell(self.userid, '#multi', text('ClassSelect 1',{'class':choice},playerlib.getPlayer(self.userid).get('lang')))
        else:
            self.ClassInfo()
    def ClassInfo(self, userid=None, choice=None, popupid=None):
        CMenu = popuplib.easymenu('Class info', None, self.ClassInfoSelect)
        CMenu.settitle(text('ClassInfo 1',{},playerlib.getPlayer(self.userid).get('lang')))
        for Class in Class_List:
            CMenu.addoption(Class, Class)
        if not self.characterkey['classes']:
            CMenu.addoption('pick', text('ClassInfo 2',{},playerlib.getPlayer(self.userid).get('lang')))
        CMenu.addoption('back', text('ClassInfo 3',{},playerlib.getPlayer(self.userid).get('lang')))
        CMenu.send(self.userid)
    def ClassInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice is 'pick':
            self.ClassMenu()
        elif choice is 'back':
            self.InfoMenu()
        else:
            infomenu = popuplib.create('%s info'%choice)
            infomenu.addline(text('ClassInfoSelect 1',{'choice':choice},playerlib.getPlayer(self.userid).get('lang')))
            for line in Classes[choice]['info']:
                infomenu.addline(line)
            if not self.characterkey['classes']:
                self.user.key['pending'] = choice
                infomenu.addline(text('ClassInfoSelect 2',{},playerlib.getPlayer(self.userid).get('lang')))
            infomenu.addline(text('ClassInfoSelect 3',{},playerlib.getPlayer(self.userid).get('lang')))
            infomenu.addline(text('ClassInfoSelect 4',{},playerlib.getPlayer(self.userid).get('lang')))
            infomenu.menuselect = self.InfoClasseselect
            infomenu.send(self.userid)
    def InfoClasseselect(self, userid=None, choice=None, popupid=None):
        if choice is 8 and self.user.key['pending'] and not self.characterkey['classes']:
            self.Classeselect(choice=self.user.key['pending'])
        elif choice is 9:
            self.ClassInfo()
        self.user.key['pending'] = None
    def MultiMenu(self, userid=None, choice=None, popupid=None):
        UserKey = Character(self.userid).key
        if len(UserKey['classes']) is 2:
            classes = UserKey['classes'].keys()
            if classes[1] < classes[0]:
                up = 1
            else:
                up = 0
            UserKey['classes'][classes[up]] += 1
            es.tell(self.userid, '#multi', text('MultiMenu 1',{'class':classes[up],'level':UserKey['classes'][classes[up]]},playerlib.getPlayer(self.userid).get('lang')))
        else:
            clas = UserKey['classes'][classes[up]].keys()[0]
            CMenu.popuplib.easymenu('cmenu',None,self.MultiMenuSelect)
            CMenu.settitle(text('MultiMenu 2',{},playerlib.getPlayer(self.userid).get('lang')))
            CMenu.addoption('cur', text('MultiMenu 3',{'class':clas},playerlib.getPlayer(self.userid).get('lang')))
            for x in Class_List:
                if x is not clas:
                    CMenu.addoption(x, x)
            CMenu.send(self.userid)
    def MultiMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice is 'cur':
            for x in self.key['classes']:
                self.key['classes'][x] += 1
                es.tell(self.userid, '#multi', text('MultiMenuSelect 1',{'class':x},playerlib.getPlayer(self.userid).get('lang')))
        else:
            Character(self.userid).key['classes'][choice] = 1
            es.tell(self.userid, '#multi', text('MultiMenuSelect 2',{'class':choice},playerlib.getPlayer(self.userid).get('lang')))
        Character(self.userid).key['unspent level'] -= 1
#Begin Player Class
class Player(object):
    global Players
    def __init__(self, userid):
        self.userid = int(userid)
        self.steamid = es.getplayersteamid(self.userid)
        self.name = es.getplayername(self.userid)
        if not Players.has_key(self.userid):
            Players[self.userid] = {}
            Players[self.userid]['character'] = None
            Players[self.userid]['pending'] = None
            Players[self.userid]['characters list'] = []
            Players[self.userid]['delay list'] = []
            Players[self.userid]['gravity'] = 1.0
        self.attributes = es.createplayerlist(self.userid)[self.userid]
        self.key = Players[self.userid]
    def Update(self):
        pass
    def CheckCharacter(self):
        for x in Characters:
            if Characters[x]['creator'] == self.steamid:
                if not self.key['character']:
                    self.key['character'] = x
                if x not in self.key['characters list']:
                    self.key['characters list'].append(x)
        if not self.key['character']:
            Character(self.userid).Setup(self.name, 1)
    def AddCharacter(self, Name):
        self.key['characters list'].append(Name)
        self.key['character'] = Name
    def SetCharacter(self, Name):
        if Characters.has_key(Name):
            if not self.LoopCharacter(Name):
                self.key['character'] = Name
                es.tell(self.userid, '#multi', text('SetCharacter 1',{'name':Name},playerlib.getPlayer(self.userid).get('lang')))
            else:
                es.tell(self.userid, '#multi', text('SetCharacter 2',{'name':Name},playerlib.getPlayer(self.userid).get('lang')))
        else:
            es.tell(self.userid, '#multi', text('SetCharacter 3',{'name':Name},playerlib.getPlayer(self.userid).get('lang')))
    def LoopCharacter(self, Name):
        for x in es.getUseridList():
            if Players[x]['character'] == Name:
                return 1
        return 0
    def TempCharacter(self, Name):
        if Characters.has_key(Name):
            if Characters[Name]['password'] != 'locked':
                self.key['pending'] = Name
                es.tell(self.userid, '#multi', text('TempCharacter 1',{'name':Name},playerlib.getPlayer(self.userid).get('lang')))
                es.escinputbox(10, self.userid, text('TempCharacter 2',{},playerlib.getPlayer(self.userid).get('lang')), text('TempCharacter 3',{},playerlib.getPlayer(self.userid).get('lang')), 'dnd passwordenter')
            else:
                es.tell(self.userid, '#multi', text('TempCharacter 3',{'name':Name},playerlib.getPlayer(self.userid).get('lang')))
        else:
            es.tell(self.userid, '#multi', text('TempCharacter 4',{},playerlib.getPlayer(self.userid).get('lang')))
    def PasswordEnter(self, Password):
        if self.key['pending']:
            if Password == Characters[self.key['pending']]['password']:
                self.SetCharacter(self.key['pending'])
            else:
                es.tell(self.userid, '#multi', text('PasswordEnter 1',{'password':Password,'pending':self.key['pending']},playerlib.getPlayer(self.userid).get('lang')))
            self.key['pending'] = None
        else:
            es.tell(self.userid, '#multi', text('PasswordEnter 2',{},playerlib.getPlayer(self.userid).get('lang')))
    def CharacterMenu(self):
        CMenu = popuplib.easymenu('CMenu', '_popup_choice', self.CharacterMenuSelect)
        CMenu.settitle(text('CharacterMenu 1',{'name':self.name},playerlib.getPlayer(self.userid).get('lang')))
        for x in self.key['characters list']:
            CMenu.addoption(x, x)
        CMenu.send(self.userid)
    def CharacterMenuSelect(self, userid, choice, popupid):
        es.sexec(self.userid, 'dnd load %s'%choice)
    def Delayed(self, duration, function, parama=(), Endround=None):
        if not Endround:
            gamethread.delayedname(duration, len(self.key['delay list'])+1, function, parama)
            self.key['delay list'].append(len(self.key['delay list'])+1)
        else:
            gamethread.delayedname(duration, len(Players['delay list'])+1, function, parama)
            Players['delay list'].append(len(Players['delay list'])+1)
#End Player Class
#Begin Character Class
class Character(object):
    global Characters
    def __init__(self, userid=None):
        self.userid = int(userid)
        self.steamid = es.getplayersteamid(self.userid)
        self.character = Players[self.userid]['character']
        if self.character:
            self.key = Characters[self.character]
        self.player = playerlib.getPlayer(self.userid)
        self.user = Player(self.userid)
    def Update(self):
        pass
    def Setup(self, Name, Forced=None):
        if not Characters.has_key(Name):
            if self.player.get('isdead'):
                self.Create(Name)
            elif Forced:
                self.Create(Name)
            else:
                es.tell(self.userid, '#multi', text('Setup 1',{},playerlib.getPlayer(self.userid).get('lang')))
        elif Forced:
            self.Setup('%sX'%Name, 1)
        else:
            es.tell(self.userid, '#multi', text('Setup 2',{'name':Name},playerlib.getPlayer(self.userid).get('lang')))
    def Create(self, Name):
        Characters[Name] = {}
        Characters[Name]['creator'] = self.steamid
        Characters[Name]['race'] = 'Pending'
        Characters[Name]['classes'] = {}
        Characters[Name]['password'] = 'locked'
        Characters[Name]['xp'] = 0
        Characters[Name]['level'] = 1
        Characters[Name]['unspent level'] = 0
        Player(self.userid).AddCharacter(Name)
        Menu(self.userid).RaceMenu()
        es.tell(self.userid, '#multi', text('Create 1',{'name':Name},playerlib.getPlayer(self.userid).get('lang')))
    def SetPassword(self, Password):
        Characters[self.character]['password'] = Password
        es.tell(self.userid, '#multi', text('SetPassword',{'character':self.character,'password':Password},playerlib.getPlayer(self.userid).get('lang')))
    def GiveXp(self, amount, reason):
        if self.key['xp'] < Levels[30]:
            self.key['xp'] += amount
            if self.key['xp'] >= Levels[self.key['level']+1]:
                self.key['level'] += 1
                if len(self.key['classes']) is 1 and self.key['level'] is not 10 and self.key['level'] is not 20:
                    for x in self.key['classes']:
                        self.key['classes'][x] += 1
                else:
                    Characters[Name]['unspent level'] += 1
                    Menu(self.userid).MultiMenu()
                es.tell(self.userid, '#multi', text('GiveXp 1',{'level':self.key['level']},playerlib.getPlayer(self.userid).get('lang')))
            else:
                es.tell(self.userid, '#multi', text('GiveXp 2',{'amount':amount,'reason':reason},playerlib.getPlayer(self.userid).get('lang')))
        else:
            self.key['xp'] = Levels[30]
#End Classes
#Begin handels for our 'dnd' command that can be run in client console/chat
def Command():
    userid = int(es.getcmduserid())
    steamid = es.getplayersteamid(userid)
    player = playerlib.getPlayer(userid)
    arg1 = es.getargv(1).lower()
    argcount = es.getargc()
    stringcount = 2
    commandstring = ''
    while stringcount < argcount:
        addstring = es.getargv(stringcount)
        if commandstring:
            commandstring = '%s %s'%(commandstring, addstring)
        else:
            commandstring = addstring
        stringcount += 1
    if arg1 == 'create':
        Character(userid).Setup(commandstring)
    elif arg1 == 'load':
        if player.get('isdead'):
            if Characters.has_key(commandstring):
                if Characters[commandstring]['password'] == 'locked' and Characters[commandstring]['creator'] == steamid:
                    Player(userid).SetCharacter(commandstring)
                else:
                    Player(userid).TempCharacter(commandstring)
            else:
                es.tell(userid, '#multi', text('Command 1',{'commandstring':commandstring},playerlib.getPlayer(userid).get('lang')))
    elif arg1 == 'passwordenter':
        Player(userid).PasswordEnter(commandstring)
    elif arg1 == 'passwordset':
        Character(userid).SetPassword(commandstring)
    elif arg1 == 'loadmenu':
        Player(userid).CharacterMenu()
    elif arg1 == 'menu' or arg1 == 'mainmenu':
        Menu(userid).MainMenu()
    elif arg1 == 'stats':
        Menu(userid).CharacterInformation()
    elif arg1 == 'help':
        Menu(userid).HelpMenu()
    elif arg1 == 'info':
        Menu(userid).InfoMenu()
    else:
        es.tell(userid, '#multi', text('Command 2',{'commandstring':commandstring},playerlib.getPlayer(userid).get('lang')))
#End Character Class
#End our command handels
